Hot News:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  Lisp
  Nach LISP-Durchlauf ACAD beenden

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
  
Gut zu wissen: Hilfreiche Tipps und Tricks aus der Praxis prägnant, und auf den Punkt gebracht für Autodesk Produkte
Autor Thema:  Nach LISP-Durchlauf ACAD beenden (463 mal gelesen)
Mixtur244
Mitglied
Orgelbauer

Sehen Sie sich das Profil von Mixtur244 an!   Senden Sie eine Private Message an Mixtur244  Schreiben Sie einen Gästebucheintrag für Mixtur244

Beiträge: 8
Registriert: 13.07.2021

ACAD2022

erstellt am: 13. Jul. 2021 10:56    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities


b_render.lsp

 
Hallo zusammen!
Bin absoluter LISP-Anfänger und stehe vor einem Rätsel: Aus Beiträgen hier im Forum (Dank an alle Uploader!) habe ich beiliegende LISP-Routine gebastelt. Sie renderd automatische alle definierten Ansichten einer DWG und speichert sie ins Quellverzeichnis. Der Teil über den ==== tut genau das. Der Teil darunter soll DANACH die Datei ohne zu speichern verlassen und ACAD schließen. Das tut er auch, aber nicht DANACH, sondern unmittelbar. Ich suche also nach so einer Art Wenn-Dann Schleife, damit der untere Teil erst abgearbeitet wird, wenn der obere mit allen Ansichten fertig ist.

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADwiesel
Moderator
CAD4FM UG




Sehen Sie sich das Profil von CADwiesel an!   Senden Sie eine Private Message an CADwiesel  Schreiben Sie einen Gästebucheintrag für CADwiesel

Beiträge: 1948
Registriert: 05.09.2000

AutoCAD, Bricscad
Wir machen das Mögliche unmöglich

erstellt am: 13. Jul. 2021 11:17    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Mixtur244 10 Unities + Antwort hilfreich

Willkommen hier im Forum. Im richtigen Forum bist du ja schon mal gelandet.
.. Dann bau doch alle Anweisungen aus dem 2.Progrämmchen in das Erste ein und das Problem mit dem Warten auf das Ende der ersten Funktion ist erledigt.
das close muss dann als Letztes rein. Dann könnte es gehen

------------------
Gruß
CADwiesel
Besucht uns im CHAT

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cadffm
Moderator
良い精神




Sehen Sie sich das Profil von cadffm an!   Senden Sie eine Private Message an cadffm  Schreiben Sie einen Gästebucheintrag für cadffm

Beiträge: 20757
Registriert: 03.06.2002

System: F1
und Google

erstellt am: 13. Jul. 2021 11:24    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Mixtur244 10 Unities + Antwort hilfreich

ohne Erklärungen

lösche alles ab(inkl.) der Zeile "================"
Dann packe vor die letzte schließende Klammer von c:b_render folgende Zeile:
(if (= (getvar "dbmod") 0) (command "_.QUIT") (command "_.QUIT" "_y"))

Wenn es jetzt die einzige offene Datei war, dann sollte AutoCAD schließen.

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

spider_dd
Mitglied



Sehen Sie sich das Profil von spider_dd an!   Senden Sie eine Private Message an spider_dd  Schreiben Sie einen Gästebucheintrag für spider_dd

Beiträge: 1064
Registriert: 27.11.2003

Win 10Pro
Intel(R) Core(TM) i7-7700
NVIDIA Quadro P1000
ACAD, Civil-3D 2018

erstellt am: 13. Jul. 2021 11:28    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Mixtur244 10 Unities + Antwort hilfreich

Hallo Mixtur,
momentan definierts Du eine Funktion raus, die aber nie aufgerufen wird.
Dafür steht Deine letzte Zeile (command "_quit") außerhalb aller Funktionen und wird daher beim laden sofort ausgeführt, denke ich mal (jetzt nicht getestet).

Alles weitere ist ja schon gesagt.

Gruß
Thomas

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Mixtur244
Mitglied
Orgelbauer

Sehen Sie sich das Profil von Mixtur244 an!   Senden Sie eine Private Message an Mixtur244  Schreiben Sie einen Gästebucheintrag für Mixtur244

Beiträge: 8
Registriert: 13.07.2021

ACAD2022

erstellt am: 13. Jul. 2021 11:52    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Dank an alle! Jetzt klappt es! Vielleicht habe ich ja sogar etwas gelernt für den nächsten Versuch... 

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Mixtur244
Mitglied
Orgelbauer

Sehen Sie sich das Profil von Mixtur244 an!   Senden Sie eine Private Message an Mixtur244  Schreiben Sie einen Gästebucheintrag für Mixtur244

Beiträge: 8
Registriert: 13.07.2021

ACAD2022

erstellt am: 06. Aug. 2021 10:54    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Nachdem die Routine jetzt so wunderbar läuft, kommen die weiteren Wünsche. Im ersten Teil wird mit einigen Buchstaben das Rendern im Renderfenster, die Rendervoreinstellung und die Bildauflösung festgelegt. Dabie steht das "m" in Zeile 25 für die ACAD-eigenen Voreinstellung "medium". Dabei wird die Anzahl der Renderebenen auf 5 festgelegt und die Rendegenauigkeit auf "mittel". Ich würde nun aber gerne 10 Ebenen rendern, da das die Qualität doch duetlich erhöht und die Zeit ja keine Rolle mehr spielt. Nun kann ich aber eine neue Voreinstellung nur durch Kopieren und Verändern einer bestehenden erzeugen. Und ich weiß nicht, wie ich diese dann im Script aufrufen kann. Hat jemand eine Idee? Oder kann ich die Ebenenanzahl auch dezidiert im Script angeben?

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cadffm
Moderator
良い精神




Sehen Sie sich das Profil von cadffm an!   Senden Sie eine Private Message an cadffm  Schreiben Sie einen Gästebucheintrag für cadffm

Beiträge: 20757
Registriert: 03.06.2002

System: F1
und Google

erstellt am: 06. Aug. 2021 11:42    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Mixtur244 10 Unities + Antwort hilfreich

Hi,

>>"Ich würde nun aber gerne 10 Ebenen rendern,
>>"Nun kann ich aber eine neue Voreinstellung nur durch Kopieren und Verändern einer bestehenden erzeugen."
Warum nicht die Voreinstellung HOCH nutzen?

oder in den Hilfe nachsehen welche Systemvariablen für die Renderlevel zuständig ist
und dann wählst du im Render Befehl das Benutzerdefinert statt Mittel.

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Mixtur244
Mitglied
Orgelbauer

Sehen Sie sich das Profil von Mixtur244 an!   Senden Sie eine Private Message an Mixtur244  Schreiben Sie einen Gästebucheintrag für Mixtur244

Beiträge: 8
Registriert: 13.07.2021

ACAD2022

erstellt am: 06. Aug. 2021 13:37    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Aus welchem Grund auch immer - "hoch" erzeugt ein stark pixeliges Bild mit extremem Rauschen. Vielleicht wird das Ergebnis jenseits von 10 Renderebenen sensationell. Aber bis dahin ist das Ergebnis nicht vorzeigbar.

Im Übrigen habe ich das Problem gelöst. Der Trick besteht darin, dass die Reihenfolge der Abfragen sich bei benutzerdefinierter Vorlage ändert und daher dann auch die Abfolge der Antworten in der Lisp-Routine angepasst werden muss.

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Mixtur244
Mitglied
Orgelbauer

Sehen Sie sich das Profil von Mixtur244 an!   Senden Sie eine Private Message an Mixtur244  Schreiben Sie einen Gästebucheintrag für Mixtur244

Beiträge: 8
Registriert: 13.07.2021

ACAD2022

erstellt am: 01. Sep. 2021 13:25    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Nun benötige ich doch noch einmal Hilfe.
Da die Batch-Verarbeitung mit mittlerer Qualität läuft, wollte ich mir eine zweite Routine bereitlegen, um eine vorgewählte Ansicht mit hoher Qualität zu rendern, zu speichern und ACAD zu schließen. Ich habe dafür einen Teil aus der Batch-Routine verwendet:

(command ".render"
        "b"
        "mittel - 2 kopieren"
        "r"
        "1000"
        "707"
        "j"
        (strcat cur_dir cur_name ".jpeg")
)
((command "_.QUIT") (command "_.QUIT" "_y") 
)

Leider funktioniert es nicht. Die Frage nach Pfad und Name wird mit " ; Fehler: Fehlerhafter Argumenttyp: stringp nil" beantwortet. Was stimmt hier nicht?

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cadffm
Moderator
良い精神




Sehen Sie sich das Profil von cadffm an!   Senden Sie eine Private Message an cadffm  Schreiben Sie einen Gästebucheintrag für cadffm

Beiträge: 20757
Registriert: 03.06.2002

System: F1
und Google

erstellt am: 01. Sep. 2021 13:38    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Mixtur244 10 Unities + Antwort hilfreich

Ich vermute dein AutoCAD hat keine Ahnung was du mit  cur_dir cur_name meinst,
an das Symbol ist kein Wert gebunden und somit auch kein String - der erwartet wird von STRCAT.

wenn man einfach mal schraibt (strcat habeichmirausgedacht) so macht das auch keinen Sinn, aber in dem Fall liegt es dem Betrachter oft auf der Hand,  (strcat cur_dir cur_name ".jpeg") ist nichts anderes solange cur_dir cur_name keinen Wert hat.

Du mußt also  cur_dir cur_name zunächst mal füttern damit AutoCAD danach  cur_dir cur_name und ".jpeg" zusammenfügen kann.

(strcat "A" "B" "C")

oder auch
(setq  cur_dir cur_name "aha")
(strcat  cur_dir cur_name ".jpeg")


Da dir ja bereits ein funktionierender Ablauf vorliegt wirst du schnell das Problem lösen.

Werte an ein Symbol binden geht zB mit SETQ, also wirst du soetwas in deinem funktionierendem Code finden sollen

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Mixtur244
Mitglied
Orgelbauer

Sehen Sie sich das Profil von Mixtur244 an!   Senden Sie eine Private Message an Mixtur244  Schreiben Sie einen Gästebucheintrag für Mixtur244

Beiträge: 8
Registriert: 13.07.2021

ACAD2022

erstellt am: 01. Sep. 2021 14:29    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Ohne SInn und Verstand, das trifft es schon ganz gut! Tatsächlich habe ich von Lisp keine Ahnung. Aber nachdem ich auch die entsprechenden setvar-Zeilen kopiert habe, geht es nun. Danke für den Hinweis, dass cur_dir und cur_name keine Lisp-ELemente sondern Variablen sind!

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cadffm
Moderator
良い精神




Sehen Sie sich das Profil von cadffm an!   Senden Sie eine Private Message an cadffm  Schreiben Sie einen Gästebucheintrag für cadffm

Beiträge: 20757
Registriert: 03.06.2002

System: F1
und Google

erstellt am: 01. Sep. 2021 14:36    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Mixtur244 10 Unities + Antwort hilfreich

Mein Sorry, ich dachte von Juli bis heute sind die ersten Lisp-Funktionen wie SETQ STRCAT schon nicht mehr so fremd 
Um so toller wenn es jetzt doch funktioniert - auch ohne Silbertablett
www.autolisp.info 
Tutorial: Getting Started (AutoLISP)

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP



Programmentwickler CAD & Office (m/w/divers)

thyssenkrupp ist eine international aufgestellte Unternehmensgruppe aus weitgehend selbstständigen Industrie- und Technologiegeschäften mit über 100.000 Mitarbeitenden. In 56 Ländern erwirtschaftete die Gruppe im Geschäftsjahr 2020/2021 einen Umsatz von 34 Mrd ?. Mit umfassendem Technologie-Know-how entwickeln die Geschäfte und alle Mitarbeitenden wirtschaftliche und ressourcenschonende ...

Anzeige ansehenSoftwareentwicklung
Mixtur244
Mitglied
Orgelbauer

Sehen Sie sich das Profil von Mixtur244 an!   Senden Sie eine Private Message an Mixtur244  Schreiben Sie einen Gästebucheintrag für Mixtur244

Beiträge: 8
Registriert: 13.07.2021

ACAD2022

erstellt am: 01. Sep. 2021 14:54    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Ja, so geht's:

(defun c:e_render (/ viewlist)
  (setq cur_dir (getvar "dwgprefix")
  )
  (setq cur_name (substr (getvar "dwgname")
                        1
                        (- (strlen (getvar "dwgname")) 4)
                )
  )
  (command ".render"
        "b"
        "mittel - 2 kopieren"
        "r"
        "4000"
        "2828"
        "j"
        (strcat cur_dir cur_name ".jpeg")
  )
  (princ)
  ((command "_.QUIT") (command "_.QUIT" "_y") 
  )
)

Bleibt nur eine Frage: Laut ACAD Hilfe kann man in Datei mit bis zu 12000x12000 Pixel rendern. Jeder Wert über 4096 erzeugt aber einen Fehler. Warum? Wie kann ich größere Auflösungen erzeugen?

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2021 CAD.de | Impressum | Datenschutz